@import '../../styles/variables';
@import '../../styles/mixins';

.cui-input-hints {
  margin-top: .25rem;
  @include cui-text(s);
  color: $cui-form-hint-color;
  transition: color $cui-focus-transition;

  > * {
    margin: .25rem 0 0;
  }
}

.cui-form-field {
  display: flex;
  flex-direction: column;
  min-width: 0;

  &.disabled {
    opacity: $cui-disabled-opacity;

    .cui-form-field-label,
    .cui-input-wrapper {
      & {
        cursor: not-allowed;
      }

      & * {
        pointer-events: none;
      }
    }
  }

  .cui-input-info {
    @include cui-text(s);
    height: 1rem;
    display: flex;
    align-items:center;
    justify-content: space-between;
    color: $cui-form-label-color;
    margin-bottom: .5rem;
    transition: color $cui-focus-transition;

    cui-form-field-label {
      flex-grow:1;
    }

    .cui-input-info-right {
      flex-grow:0;
      display: flex;
      justify-content: flex-end;
    }
  }

  .cui-input-count {
    white-space: nowrap;
  }

  .cui-input-wrapper {
    display: inline-flex;
    align-items: stretch;
    border-radius: cui-border-radius(m);
    transition: box-shadow $cui-focus-transition, background-color $cui-focus-transition;
  }

  &.cui-form-field-touched.cui-form-field-invalid .cui-input-wrapper {
    outline: 1px solid $cui-input-border-color-error;
  }

  &.cdk-keyboard-focused.cui-form-field-touched.cui-form-field-invalid .cui-input-wrapper,
  &.cdk-program-focused.cui-form-field-touched.cui-form-field-invalid .cui-input-wrapper {
    outline: 2px solid $cui-input-border-color-error;
  }

  .cui-input-prefix,
  .cui-input-suffix {
    display: inline-flex;
    align-items: center;
    color: $cui-form-prefix-color;
    padding-left: $cui-input-padding-h - $cui-form-prefix-margin-h;
    padding-right: $cui-input-padding-h - $cui-form-prefix-margin-h;
    @include cui-no-select();
    @include cui-text(m);
  }

  .cui-input-prefix {
    margin-right: - $cui-form-prefix-margin-h - $cui-input-padding-h;
  }

  .cui-input-suffix {
    margin-left: - $cui-form-prefix-margin-h - $cui-input-padding-h;
  }

  &.cui-form-field-touched.cui-form-field-invalid {
    .cui-input-info,
    .cui-input-hints {
      color: $cui-form-error-color;
    }
  }

  &.cdk-focused {
    label {
      color: $cui-form-label-color-focus;
    }
  }

  // ----- modes

  @mixin mode($mode) {
    &[data-cui-mode='#{$mode}'] {
      .cui-input-wrapper {
        outline: 1px solid cui-color($mode, input-border);
        background-color: cui-color($mode, input-background);
      }

      &:not(.disabled) {
        .cui-input-wrapper:hover,
        &.cdk-focused .cui-input-wrapper {
          outline: 1px solid cui-color($mode, input-border-hover);
          background-color: cui-color($mode, input-background-hover);
        }

        @if $mode == 'primary' or $mode == 'ghost' {
          &.cdk-keyboard-focused .cui-input-wrapper,
          &.cdk-program-focused .cui-input-wrapper {
            outline: 2px solid $cui-focus-color;
          }
        }
      }

      /* Change Autocomplete styles in Chrome*/
      input:-webkit-autofill,
      textarea:-webkit-autofill,
      select:-webkit-autofill {
        &, &:hover, &:focus {
          -webkit-box-shadow: 0 0 0 10rem cui-color($mode, input-background) inset;
        }
      }
    }
  }

  @include mode('primary');
  @include mode('secondary');
  @include mode('ghost');
}

form .cui-form-field {
  margin-bottom: $cui-form-field-margin-bottom;
}
